-- This is written in Haskell.
{--
JVM-Bridge -- bridge from FP languages and others to the Java VM
Copyright (C) 2001 Ashley Yakeley <ashley@semantic.org>

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--}

module BasicLayer
	(
	module Type,
	module Bytes,
	module Ref,
	module HasNothing,
	module Equals,
	module Subtype,
	module MonadException,
	module ContextMonad,
	module LiftedMonad,
	module MonadThread,
	while
	) where
	{
	import MonadThread;
	import LiftedMonad;
	import ContextMonad;
	import MonadException;
	import Subtype;
	import Equals;
	import HasNothing;
	import Ref;
	import Bytes;
	import Type;

	while :: (Monad m) => m Bool -> m ();
	while test = do
		{
		cont <- test;
		if (cont) then (while test) else (return ());
		};
	}
