-- This is written in Haskell.
{--
JVM-Bridge -- bridge from FP languages and others to the Java VM
Copyright (C) 2001 Ashley Yakeley <ashley@semantic.org>

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--}

module BridgeCallback where
	{
	import Class_java_lang_Class;
	import Class_java_lang_Thread;
	import LibLayer;
	import TypedLayer;
	import JCFLayer;
	import JavaLayer;
	import BasicLayer;

	getStandardClassLoader :: (HasPreload_JClass m) => m Jjava_lang_ClassLoader;
	getStandardClassLoader = do
		{
		efClass	<- getExecuteFunctionClass;
		efNull	<- getIsNothing efClass;
--		callIO (putStrLn ("ExecuteFunction " ++ (if efNull then "not found" else "found")));
		
		getClassLoader_JClass efClass ();
		};

	defineCallbackClass :: (IsJVMMonad m,IsJavaClassMarker c,IsJavaClassMarker base) =>
		Jjava_lang_ClassLoader -> Type (ObjectRef c) -> Type (ObjectRef base) -> [ClassName] -> [ValueType] -> [MethodNameType] -> m TypedLayer.JClass;
	defineCallbackClass (MkTLRef loader) tClass tBase = tlDefineCallbackClass loader (className tClass) (className tBase);

	yieldLoop :: (HasPreload_JThread m) => m Bool -> m ();
	yieldLoop = tlYieldLoop yield_JThread;	
	}
