-- This is written in Haskell.
{--
JVM-Bridge -- bridge from FP languages and others to the Java VM
Copyright (C) 2001 Ashley Yakeley <ashley@semantic.org>

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--}

module JVMUser
	(
	JVMUser,
	getJVMUserContext
	) where
	{
	import JVMStandard;
	import JVMLoadable;
	import TypedLayer;
	import BasicLayer;
	
	type JVMUser c = ContextMonad c JVMStandard;
	
	instance ContextFailable JVMStandard c;

	instance (IsJVMLoadable JVMStandard c) => IsJVMMonad (JVMUser c) where
		{
		callIOWithEnv f = MkContextMonad (\c -> callIOWithEnv (f));

		callIOWithMapEnv f = MkContextMonad (\c -> callIOWithMapEnv (\map -> ((f) (map . (\m -> doContext m c)))));

		getRunWithEnv = MkContextMonad (\c -> do
			{
			runWithEnv <- getRunWithEnv;
			return (\env (MkContextMonad cma) -> runWithEnv env (cma c));
			});

		runWithVMAndEnv vm (MkContextMonad cma) = runWithVMAndEnv vm (do
			{
			context <- jvmLoad;
			cma context;
			});
		};
	
	getJVMUserContext :: (IsJVMLoadable JVMStandard c) => JVMUser c c;
	getJVMUserContext = getContext;

{--	
	instance (CreatableFromEnv c) => MonadThread (JVMUser c) where
		{
		fork	:: m () -> m ();
		fork foo = do
			{
			vm <- getVM;
			
			};
		yield	:: m ();
		sleep	:: Integer -> m ();	-- nanoseconds
		};
--}
{--	
	instance MonadHasNothing JVMUser VMRef where
		{
		getNothing = getNothing >>= (return . MkVMRef);	-- null ref, often used in Java
		getIsNothing (MkVMRef a) = getIsNothing a;
		};
--}	
	}
