-- This is written in Haskell.
{--
JVM-Bridge -- bridge from FP languages and others to the Java VM
Copyright (C) 2001 Ashley Yakeley <ashley@semantic.org>

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--}

module MonadThread where
	{
	-- very much the Java model of threads.
	
	class (Monad m) => MonadThread m where
		{
		fork	:: m () -> m ();
		yield	:: m ();
		sleep	:: Integer -> m ();	-- nanoseconds
		};
	
	class (MonadThread m) => ThreadLock m lock where
		{
		newLock			:: m lock;
		synchronized	:: lock -> m a -> m a;
		wait			:: lock -> m ();
		notify			:: lock -> m ();
		notifyAll		:: lock -> m ();
		};
	
	class (MonadThread m) => ThreadControl m thread where
		{
		forkThread	:: m () -> m thread;
		thisThread	:: m thread;
		wakeThread	:: thread -> m ();
		joinThread	:: thread -> m ();
		};
	}
