-- This is written in Haskell.
{--
JVM-Bridge -- bridge from FP languages and others to the Java VM
Copyright (C) 2001 Ashley Yakeley <ashley@semantic.org>

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--}

module RawCallback where
	{
	import RawEnv;
	import RawValueList;
	import RawTypes;
	import Foreign;

	foreign import ccall "ExecuteFunctionControl.h JVMBridge_StartExecuteFunction" rawStartExecuteFunction	:: RawEnv -> IO ();

	foreign import ccall "wrapper" rawMakeVoidCallback		:: (RawEnv -> RawValueList -> IO RawVoid)		-> IO (FunPtr ());
	foreign import ccall "wrapper" rawMakeBooleanCallback	:: (RawEnv -> RawValueList -> IO RawBoolean)	-> IO (FunPtr ());
	foreign import ccall "wrapper" rawMakeByteCallback		:: (RawEnv -> RawValueList -> IO RawByte)		-> IO (FunPtr ());
	foreign import ccall "wrapper" rawMakeCharCallback		:: (RawEnv -> RawValueList -> IO RawChar)		-> IO (FunPtr ());
	foreign import ccall "wrapper" rawMakeShortCallback		:: (RawEnv -> RawValueList -> IO RawShort)		-> IO (FunPtr ());
	foreign import ccall "wrapper" rawMakeIntCallback		:: (RawEnv -> RawValueList -> IO RawInt)		-> IO (FunPtr ());
	foreign import ccall "wrapper" rawMakeLongCallback		:: (RawEnv -> RawValueList -> IO RawLong)		-> IO (FunPtr ());
	foreign import ccall "wrapper" rawMakeFloatCallback		:: (RawEnv -> RawValueList -> IO RawFloat)		-> IO (FunPtr ());
	foreign import ccall "wrapper" rawMakeDoubleCallback	:: (RawEnv -> RawValueList -> IO RawDouble)		-> IO (FunPtr ());
	foreign import ccall "wrapper" rawMakeObjectCallback	:: (RawEnv -> RawValueList -> IO RawGlobalRef)	-> IO (FunPtr ());
	}
