-- This is written in Haskell.
{--
JVM-Bridge -- bridge from FP languages and others to the Java VM
Copyright (C) 2001 Ashley Yakeley <ashley@semantic.org>

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--}

module TypedMonad where
	{
	import VMLayer;
	import BasicLayer;

	callIOWithMap :: (LiftedMonad IO m) => ((m a -> IO a) -> IO b) -> m b;
	callIOWithMap = callWithMap;

	callIO :: (LiftedMonad IO m) => IO a -> m a;
	callIO = call;

	class (LiftedMonad IO m) => IsJVMMonad m where
		{
		callIOWithMapEnv	:: ((?jvmenv :: VMEnv) => (m a -> IO a) -> IO b) -> m b;
		callIOWithEnv		:: ((?jvmenv :: VMEnv) => IO a) -> m a;
--		getRunWithEnv		:: m ((?jvmenv :: VMEnv) => m a -> IO a); GHC infelicity disallows
		getRunWithEnv		:: m (VMEnv -> m a -> IO a);
		runWithVMAndEnv		:: (?jvmenv :: VMEnv) => JavaVM -> m a -> IO a;
		callIOWithEnv foo = callIOWithMapEnv (\_ -> foo);
		};

	runWithVM :: (IsJVMMonad m) => JavaVM -> m a -> IO a;
	runWithVM vm f = vmAttachedThread vm (runWithVMAndEnv vm f);

{--	Can't do this unfortunately
	instance (LiftedMonad IO m) => MonadHasNothing m VMRef where
		{
		getNothing = call getNothing;
		getIsNothing a = call (getIsNothing a);
		};
--}
	}
