-- This is written in Haskell.
{--
JVM-Bridge -- bridge from FP languages and others to the Java VM
Copyright (C) 2001 Ashley Yakeley <ashley@semantic.org>

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--}

module TypedThrowable
	(
	Class_JThrowable,JThrowable
	,throwJThrowable,catchJThrowable
	) where
	{
	import TypedObject;
	import TypedReference;
	import TypedMonad;
	import VMLayer;
	import JavaLayer;
	import BasicLayer;
--	import MonadError;

	data Class_JThrowable;
	instance IsJavaClassMarker Class_JThrowable where
		{
		cName Type = toJavaString "java/lang/Throwable";
		};
	type JThrowable = ObjectRef Class_JThrowable;

	throwJThrowable :: (IsJVMMonad m) => JThrowable -> m a;
	throwJThrowable (MkTLRef th) = callIOWithEnv (vmThrow th);

	catchJThrowable :: (IsJVMMonad m) => m a -> (JThrowable -> m a) -> m a;
	catchJThrowable foo catchClause = callIOWithMap (\map -> catch (map foo) (\x -> map (do
		{
		exRef <- callIOWithEnv (vmGetClearException);
		noEx <- callIO (getIsNothing exRef);
		if noEx
			then (callIO (ioError x))
			else catchClause (MkTLRef exRef);
		})));

	instance (IsJVMMonad m) => MonadException JThrowable m where
		{
		throwException = throwJThrowable;
		catchException = catchJThrowable;
		};

{-- broken in 5.02
	instance (IsJVMMonad m) => MonadError JThrowable m where
		{
		throwError = tlThrow;
		catchError = tlCatch;
		};
--}
	}
