-- This is written in Haskell.
{--
JVM-Bridge -- bridge from FP languages and others to the Java VM
Copyright (C) 2001 Ashley Yakeley <ashley@semantic.org>

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--}

module TypedValue
	(
	IsJVMValue(..)
	) where
	{
	import TypedReturnable;
	import TypedMonad;
	import VMLayer;
	import JavaLayer;
	import BasicLayer;
	import Word;
	
	class (IsJVMReturnable t) => IsJVMValue t where
		{
		getValueType				:: Type t -> ValueType;
		tlAppendArgumentToValueList	:: IsJVMMonad m => VMValueList-> t -> m ();
		tlGetNthValueAs				:: IsJVMMonad m => VMValueList -> Word16 -> m t;

		tlGetStaticField			:: IsJVMMonad m => VMRef -> VMStaticFieldID -> m t;
		tlSetStaticField			:: IsJVMMonad m => VMRef -> VMStaticFieldID -> t -> m ();
		tlGetField					:: IsJVMMonad m => VMRef -> VMFieldID -> m t;
		tlSetField					:: IsJVMMonad m => VMRef -> VMFieldID -> t -> m ();

		tlNewArray					:: IsJVMMonad m => Type t -> Jint -> m VMRef;
		tlGetArrayElement			:: IsJVMMonad m => VMRef -> Jint -> m t;
		tlGetArrayRegion			:: IsJVMMonad m => VMRef -> Jint -> Jint -> m [t];
		tlSetArrayElement			:: IsJVMMonad m => VMRef -> Jint -> t -> m ();
		tlSetArrayRegion			:: IsJVMMonad m => VMRef -> Jint -> [t] -> m ();
		};
	}
