dnl JVM-Bridge -- bridge from FP languages and others to the Java VM
dnl Copyright (C) 2001 Ashley Yakeley <ashley@semantic.org>
dnl
dnl This library is free software; you can redistribute it and/or
dnl modify it under the terms of the GNU Lesser General Public
dnl License as published by the Free Software Foundation; either
dnl version 2.1 of the License, or (at your option) any later version.
dnl
dnl This library is distributed in the hope that it will be useful,
dnl but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
dnl Lesser General Public License for more details.
dnl
dnl You should have received a copy of the GNU Lesser General Public
dnl License along with this library; if not, write to the Free Software
dnl Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
dnl

dnl package specification:
dnl http://www.haskell.org/ghc/docs/latest/html/users_guide/packages.html#installed-pkg-info

name: PACKAGENAME
version: 0.3.1
exposed: True
exposed-modules: BasicLayer
                 BridgeCallback
                 BridgeInvocation
                 BridgeLayer
                 BridgeThread
                 Bytes
                 Class_java_lang_Class
                 Class_java_lang_Object
                 Class_java_lang_Thread
                 ContextMonad
                 Equals
                 HasNothing
                 Header_Java
                 Header_JavaX
                 Header_Misc
                 Header_OMG
                 Invocation
                 JavaLayer
                 JavaText
                 JavaTypes
                 JavaTypeSig
                 JCFAttribute
                 JCFCallbackConstructor
                 JCFCallbackField
                 JCFCallbackFinalizer
                 JCFCallback
                 JCFCallbackMethod
                 JCFCallbackTypes
                 JCFCodeInstruction
                 JCFConstantPool
                 JCFDefinition
                 JCFFormat
                 JCFLayer
                 JCFWritable
                 JVMBoot
                 JVMBridge
                 JVMLayer
                 JVMLoadable
                 JVMStandard
                 JVMUser
                 LibLayer
                 LibUtil
                 LiftedMonad
                 MonadException
                 MonadThread
                 RawCallback
                 RawEnv
                 RawLayer
                 RawTypes
                 RawValueList
                 RawVM
                 Ref
                 Subtype
                 TypedArgumentList
                 TypedArray
                 TypedCallback
                 TypedClass
                 TypedField
                 TypedLayer
                 TypedListArray
                 TypedMethod
                 TypedMonad
                 TypedNewObject
                 TypedObject
                 TypedPrimitive
                 TypedReference
                 TypedReturnable
                 TypedString
                 TypedThread
                 TypedThrowable
                 TypedTuple
                 TypedValue
                 Type
                 VMArray
                 VMCallback
                 VMCall
                 VMClass
                 VMFieldAccess
                 VMFieldID
                 VMLayer
                 VMMethodID
                 VMNewObject
                 VMObject
                 VMRef
                 VMString
                 VMStringPtr
                 VMThread
                 VMThrowable
                 VMTypes
                 VMValueList
import-dirs: importsdir/
library-dirs: libdir/`'patsubst(patsubst(JVM_LDFLAGS,`-l[^ 	]+',`'),`[ 	]*-L\([^ 	]+\)[   ]*',`
              \1')
dnl Library order is important. HaskellJVMBridge must come after JVMBridge.
extra-libraries: stdc++, JVMBridge, JVMInvocation, HaskellJVMBridge`'patsubst(patsubst(patsubst(JVM_LDFLAGS,`-framework[ 	]+[^ 	]+',`'),`-L[^ 	]+',`'),`[ 	]*-l\([^ 	]+\)[ 	]*',`, \1')
depends: lang, concurrent, haskell98

dnl "The ability to specify extra GHC options in a package was
dnl a misfeature that we removed."
dnl http://www.mail-archive.com/glasgow-haskell-users@haskell.org/msg07966.html
dnl extra-ghc-opts: -fglasgow-exts -fallow-undecidable-instances

ld-options: ifelse(regexp(JVM_LDFLAGS,`-framework'),`-1',
            `"-Wl,-rpath,libdir/"`'patsubst(patsubst(JVM_LDFLAGS,`-l[^ 	]+',`'),`[ 	]*-L\([^ 	]+\)[ 	]*',`
            "-Wl,-rpath,\1"')',`')
