/*
JVM-Bridge -- bridge from FP languages and others to the Java VM
Copyright (C) 2001 Ashley Yakeley <ashley@semantic.org>

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// preprocessor only in this file, it's used for both C++ and Java.
#ifndef __Configure_h__
#define __Configure_h__

#include "autoheader.h"

#ifndef DEBUG
#define DEBUG 0
#endif

#ifndef DEBUGINFO
#define DEBUGINFO DEBUG
#endif

#ifndef DEBUGCALLS
#define DEBUGCALLS DEBUG
#endif

#ifndef DEBUGVM
#define DEBUGVM DEBUG
#endif

#ifndef DEBUGEXCEPTION
#define DEBUGEXCEPTION DEBUGCALLS
#endif

#ifndef DEBUGGC
#define DEBUGGC DEBUGCALLS
#endif

#ifndef DEBUGTHREAD
//#define DEBUGTHREAD DEBUGCALLS
#define DEBUGTHREAD 0
#endif

#if DEBUGCALLS
#define JDEBUGMESSAGE(s) System.err.println(s)
#else
#define JDEBUGMESSAGE(s)
#endif

#ifndef INTF_CNI
#define INTF_CNI 0
#endif

#ifndef VM_SUN
#define VM_SUN 0
#endif

#ifndef VM_IBM
#define VM_IBM 0
#endif

#ifndef VM_KAFFE
#define VM_KAFFE 0
#endif

#ifndef VM_GCJ
#define VM_GCJ 0
#endif

#ifndef ARCH_64BIT
#define ARCH_64BIT 0
#endif

#ifndef JOpaqueAddress
#if ARCH_64BIT
// Java long is 64 bits
#define JOpaqueAddress long
#else
// Java int is 32 bits
#define JOpaqueAddress int
#endif
#endif

#ifndef COpaqueAddress
// C equivalent of JOpaqueAddress
#if ARCH_64BIT
#define COpaqueAddress jlong
#else
#define COpaqueAddress jint
#endif
#endif

#ifndef SigOpaqueAddress
// signature of JOpaqueAddress
#if ARCH_64BIT
#define SigOpaqueAddress "J"
#else
#define SigOpaqueAddress "I"
#endif
#endif

#ifndef SYNCH
// synchronise all function executions
#define SYNCH 1
#endif

#endif
